/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SUBGRUPPROD                                              */
/* Tabela : SUBGRUPPROD                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 28/04/2003 - Marcelo Alexsandro Souza Silva                                */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_SUBGRUPPROD
BEFORE INSERT OR UPDATE OR DELETE
ON SUBGRUPPROD FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUSUGP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDSUBGRPROD,0)  <> NVL(:NEW.CDSUBGRPROD,0))  OR
         (NVL(:OLD.IDTPGRPRALIM,0) <> NVL(:NEW.IDTPGRPRALIM,0)) OR
         (NVL(:OLD.NMSUBGRPROD,0)  <> NVL(:NEW.NMSUBGRPROD,0)) THEN
         :NEW.DTULTATUSUGP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('SUBGRUPPROD', '', 'CDGRUPPROD='||:OLD.CDGRUPPROD||';CDSUBGRPROD='||:OLD.CDSUBGRPROD||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE SUBGRUPPROD MODIFY DTULTATUSUGP DEFAULT SYSDATE
/
